=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2007-03-01 05:08:32 +0000
+++ bzrlib/branch.py	2007-03-05 07:33:49 +0000
@@ -654,9 +654,10 @@
 
     def _get_checkout_format(self):
         """Return the most suitable metadir for a checkout of this branch.
-        Weaves are used if this branch's repostory uses weaves.
+        Weaves are used if this branch's repository uses weaves.
         """
-        if isinstance(self.bzrdir, bzrdir.BzrDirPreSplitOut):
+        from bzrlib.remote import RemoteBzrDir
+        if isinstance(self.bzrdir, (bzrdir.BzrDirPreSplitOut, RemoteBzrDir)):
             from bzrlib.repofmt import weaverepo
             format = bzrdir.BzrDirMetaFormat1()
             format.repository_format = weaverepo.RepositoryFormat7()

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2007-03-01 05:08:32 +0000
+++ bzrlib/tests/__init__.py	2007-03-05 07:33:49 +0000
@@ -1652,7 +1652,7 @@
 
         This will fail if the original default transport for this test
         case wasn't backed by the working directory, as the branch won't
-        be on disk for us to open it.  
+        be on disk for us to open it.
 
         :param format: The BzrDirFormat.
         :returns: the WorkingTree.
@@ -1666,13 +1666,11 @@
             return b.bzrdir.create_workingtree()
         except errors.NotLocalUrl:
             # We can only make working trees locally at the moment.  If the
-            # transport can't support them, then reopen the branch on a local
-            # transport, and create the working tree there.  
-            #
-            # Possibly we should instead keep
-            # the non-disk-backed branch and create a local checkout?
-            bd = bzrdir.BzrDir.open(relpath)
-            return bd.create_workingtree()
+            # transport can't support them, then we keep the non-disk-backed
+            # branch and create a local checkout.
+            if not os.path.exists('_checkouts'):
+                os.mkdir('_checkouts')
+            return b.create_checkout('_checkouts/' + relpath)
 
     def assertIsDirectory(self, relpath, transport):
         """Assert that relpath within transport is a directory.

